#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 100010;

int n, m;
vector<int> a[N], b[N];
ll d1[N], d2[N];
bool was1[N], was2[N];

void dfs1(int v)
{
    was1[v] = true;
    for (int i = 0; i < a[v].size(); i++) {
        int u = a[v][i];
        if (!was1[u])
        {
            d1[u] = d1[v] + 1;
            dfs1(u);
        }
    }
}

void dfs2(int v)
{
    was2[v] = true;
    for (int i = 0; i < a[v].size(); i++) {
        int u = a[v][i];
        if (!was2[u])
        {
            d2[u] = d2[v] + 1;
            dfs2(u);
        }
    }
}

int main()
{
    std::ios_base::sync_with_stdio(false);
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    cin >> n >> m;
    int pred;
    for (int i = 1; i < n; i++) {
        cin >> pred;
        pred--;
        a[pred].push_back(i);
        a[i].push_back(pred);
    }
    dfs1(0);
    ll maxi = 0, ind1 = 0;
    for (int i = 0; i < n; i++) {
        if (maxi < d1[i]) {
            maxi = d1[i];
            ind1 = i;
        }
    }
    dfs2(ind1);
    ll ind2 = 0;
    maxi = 0;
    for (int i = 0; i < n; i++) {
        if (maxi < d2[i])
        {
            maxi = d2[i];
            ind2 = i;
        }
    }
    //cout << ind1 + 1 << ' ' << ind2 + 1 << ' ' << d1[ind1] << ' ' << d2[ind2] << endl;
    if (m == 1) {
        cout << d2[ind1] + 1 << endl;
        return 0;
    }
    cout << (d2[ind2] + 1) + 2 * ((m - 1) * (d1[ind1] + 1)) << endl;
    return 0;
}
